
eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
& eval 'exec perl -S $0 $argv:q'
if 0;

### Make sure copyurl is in path, or set full path here:
$GETURL = "copyurl -s";
&init;

### Memo files to generate:
mkdir("$SM/Personal",0755) unless (-d "$SM/Personal");
$WEATHER = "$SM/Personal/weather.txt";
$MOVIES = "$SM/Personal/movies.txt";
$AMC = "$SM/Personal/amc.txt";
$THELIST = "$SM/Personal/thelist.txt";

#
# Weather report
#
if (&OutOfDate($WEATHER, 0.2) && !fork)
{
    @new_weather = split(/\015?\n/,
	`$GETURL http://www.wunderground.com/US/CA/Mountain_View.html`);
    $mode = 0;
 
    foreach $line (@new_weather)
    {
	$new_weather .= "$1\n" if ($line =~ /<title>(.*)<\/title>/);
	next unless ($mode || $line =~ /Observed at .*Moffett/);
	unless ($mode) { $mode = 1; next }
	if ($mode <= 2)
	{
	    while ($line =~ s|<td>(.*?)</td>||)
	    {
		$bit = $1;
		$bit =~ s/<.*?>//g;
		$bit =~ s|&#176;||;
		if ($bit =~ /^Moon/) { $mode = 3; next }
		if ($mode==1)
		{
		    $new_weather .= "$bit: ";
		    $mode = 2;
		} else {
		    $new_weather .= "$bit\n";
		    $mode = 1;
		}
	    }
	    next;
	}
	next unless ($mode > 3 || $line =~ /Forecast as of/);
	if ($mode <= 3) { $mode=4; $new_weather .= "\nForecast as of "; next }
	if ($line =~ m|^</table><table>|)
	{
	    $mode = 5;
	    $new_weather .= "\n";
	    while ($line =~ s|<th[^>]*>(.*?)</th>||)
	    {
		$new_weather .= "  $1\n" if ($1);
	    }
	    next;
	}
	if ($mode == 5)
	{
	    if ($line =~ /<th>/)
	    {
		while ($line =~ s|<th>(.*?)</th>||)
		{
		    push(@cols, $1);
		}
		next;
	    }
	    if ($line =~ m|</table>|)
	    {
		foreach $x (@vals)
		{
		    foreach $i (0..$#$x)
		    {
			$new_weather .= "$cols[$i]: $x->[$i]\n";
		    }
		}
		$mode = 6;
		$new_weather .= "\n";
		next;
	    }
	    next unless ($line =~ /Mountain View/ || $line =~ /San Jose/);
	    $x = [];
	    unshift(@vals, $x);
	    while ($line =~ s|<td>(.*?)</td>||)
	    {
		push(@{$vals[0]}, $1);
	    }
	    next;
	}
	last if ($mode == 6 && $line =~ m|</TABLE>|);
	$line =~ tr/a-z/A-Z/ if ($line =~ /size="\+2">/);
	$line =~ s/<[^>]*>//g;
	next unless ($line);
	$new_weather .= "$line\n";
    }
 
    &Update($WEATHER, $new_weather);
    exit;
}

#
# Century Theaters movie listings
#
if (&OutOfDate($MOVIES) && !fork)
{
    @new_movies = split(/\015\n?/,
       `$GETURL 'http://www.centurytheatres.com/schedule/nca.htm'`);

    $new_movies = "Century Theaters\n\n" if (@new_movies);
    foreach $line (@new_movies)
    {
	next unless ($line);
	if ($skip) { $skip--; next }
	next unless ($mtv || $line =~ /NAME="anchor17".*Century/);
	unless ($mtv) {
	    $line = "CENTURY CINEMA";
	    $mtv = 1; $max = 2; $skip = 1;
	}

	$line =~ s/<BR>//g;
	$blank++ unless ($line);
	next unless ($blank < $max || $line =~ /NAME="anchor03".*Century/);
	if ($blank >= $max) {
	    $line = "CENTURY 21-25";
	    $blank = 0; $max = 2; $skip = 1;
	}

	$line =~ s/<[^>]*>//g;
	$new_movies .= "$line\n";
    }

    &Update($MOVIES, $new_movies);
    exit;
}

#
# AMC Saratoga movie listings
#
if (&OutOfDate($AMC) && !fork)
{
    @new_amc = split(/<TD[^>]*>/,
	`$GETURL 'http://amctheaters.com/db?MIval=selektOtron&metro_area=San+Jose&title=All+Titles&theater=AMC+Saratoga+14'`);

    $new_amc = "AMC Saratoga 14\n" if (@new_amc);
    $* = 1;
    foreach $line (@new_amc)
    {
	$new_amc .= "$1\n\n"
	    if ($line =~ m|<SELECT NAME="showdate">| &&
		$line =~ m|<OPTION SELECTED> ?([^\015]*)\015?$|);
	$new_amc .= "$1 - $2\n"
	    if ($line =~ m|^<A .*>(.*)</A>.*([Rr]ated[^<]*)<|);
	$new_amc .= "$1\n"
	    if ($line =~ m|\d\d<BR>(.*)<|);
    }

    &Update($AMC, $new_amc);
    exit;
}

#
# TheList concerts
#
if (&OutOfDate($THELIST) && !fork)
{
    @new_concerts = split(/\015?\n/,
       `$GETURL 'http://www.luini.com/mail2/thelist.html'`);

    chop($date = `date "+%b %e %a"`);
    $date =~ tr/A-Z/a-z/;
    $date =~ s/  / /;
    $date =~ s/thu/thr/;
    $new_concerts = "Concerts - funk-punk-thrash-ska\n" if (@new_concerts);

    foreach $line (@new_concerts)
    {
	next unless ($now || $line =~ /<H3>$date</);
	$now = 1 unless ($now);

	$cap = ($line =~ /^<TR>.*<H3>/);
	$days++ if ($cap);
	next if ($days > 8);

	$line =~ s/<[^>]*>//g;
	next unless ($line);
	if ($cap) {
	    $line =~ tr/a-z/A-Z/;
	    $line = "\n$line";
	}
	$line =~ s/^  /     /;
	$new_concerts .= "$line\n";
    }

    &Update($THELIST, $new_concerts);
    exit;
}

#
# Does file need to be updated?
#
sub OutOfDate
{
    my ($FILE, $expire) = @_;
    $expire = 0.6 unless ($expire);
    return 1 if (! -f "$FILE" || (-M "$FILE" > $expire));
    return 0;
}

#
# General File update routine
#
sub Update
{
    my ($FILE, $new_text) = @_;
    my ($date, $time, $fname);

    if ($new_text)
    {
	open(FD, ">$FILE") ||
	    print STDERR "Unable to open $FILE for write\n";
	print FD $new_text;
	close(FD);
    } else {
	$date = `date "+%I:%M:%S %p   %a %D"`;
	$fname = $FILE;
	$fname =~ s|^.+(/[^/]+/[^/]+)$|...$1|;
	open(FD, ">>$FILE") ||
	    print STDERR "Unable to open $FILE for append\n";
	print FD "Unable to retrieve/process $fname at $date";
	close(FD);
	print STDERR "Unable to retrieve/process $fname at $date";
	$time = time - 365*24*60*60;	# set time back so another attempt
	utime($time, $time, $FILE);	# will be made on next update
    }
}

wait;
wait;
wait;
wait;
exit;

sub init
{
 die "Error reading SyncMemo preferences file:\n\
~/.pilotmgr/SyncMemo/SyncMemo.prefs\n"
    if (! -f "$ENV{HOME}/.pilotmgr/SyncMemo/SyncMemo.prefs");

 eval `cat $ENV{HOME}/.pilotmgr/SyncMemo/SyncMemo.prefs`;
 $PREFS;
 die "No setting for Memo Directory found in SyncMemo preferences.\n"
    unless(defined($PREFS->{gHomeDirectory}));

 $SM = $PREFS->{gHomeDirectory};

 die "Memo directory from SyncMemo preferences doesn't exist:\n$SM\n"
    unless(-d $SM);

 my ($fn) = split(/ /, $GETURL);
 if ($fn =~ m|/|) {
   die "copyurl program not found ($fn)\n" unless (-x $fn);
 } else {
   $fn = `which $fn`;
   die "copyurl program not found ($fn)\n" if ($fn =~ /^no /);
 }
}

